"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var spawn = require("./spawn");

var reg = require("./reg");

var gitWin = require("git-win");

var path = require("path");

var url = require("url");

var fs = require("fs");

var promisify = require("util").promisify || require("util.promisify");

var curl = gitWin.toWin32("/mingw00/bin/curl.exe");

function autoRun() {
  return _autoRun.apply(this, arguments);
}

function _autoRun() {
  _autoRun = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee() {
    var cmdPath;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            cmdPath = path.join(/[\\/]node_modules[\\/]/i.test(__dirname) ? "node_modules/.bin" : "bin", "git-bash-shell.cmd"); // return reg.add(`HK${isAdmin ? "LM" : "CU"}/Software/Microsoft/Command Processor`, {

            return _context.abrupt("return", reg.add("HKCU/Software/Microsoft/Command Processor", {
              AutoRun: `
			if exist ${cmdPath} (
				call ${cmdPath}
			) else (
				if exist "%APPDATA%\\npm\\git-bash-shell.cmd" (
					call "%APPDATA%\\npm\\git-bash-shell.cmd"
				) else (
					DOSKEY cd=cd /d $* ^&^& if exist ${cmdPath} call ${cmdPath}
				)
			)
		`.replace(/\s+/g, " ").trim()
            }));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _autoRun.apply(this, arguments);
}

function urlResolve(from, to) {
  // eslint-disable-next-line node/no-deprecated-api
  return url.resolve(from, to);
}

function getLocation(_x) {
  return _getLocation.apply(this, arguments);
}

function _getLocation() {
  _getLocation = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(from) {
    var head, location;
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return spawn([curl, "--head", from], {
              argv0: "curl",
              encoding: "utf8" // echo: true,

            });

          case 2:
            head = _context2.sent;
            location = /(?:^|\r?\n)Location:\s*(.*?)(?:\r?\n|$)/i.exec(head);
            return _context2.abrupt("return", urlResolve(from, location[1]));

          case 5:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _getLocation.apply(this, arguments);
}

function checkCmder(_x2, _x3) {
  return _checkCmder.apply(this, arguments);
}

function _checkCmder() {
  _checkCmder = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(cmderDir, cmderVer) {
    var files;
    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.prev = 0;
            _context3.next = 3;
            return promisify(fs.readdir)(cmderDir);

          case 3:
            files = _context3.sent;
            _context3.next = 11;
            break;

          case 6:
            _context3.prev = 6;
            _context3.t0 = _context3["catch"](0);
            _context3.next = 10;
            return promisify(fs.mkdir)(cmderDir);

          case 10:
            return _context3.abrupt("return", false);

          case 11:
            return _context3.abrupt("return", files.some(function (file) {
              return /^Version\s+(.+)$/i.test(file) && RegExp.$1.startsWith(cmderVer);
            }));

          case 12:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this, [[0, 6]]);
  }));
  return _checkCmder.apply(this, arguments);
}

function downCmder(_x4, _x5) {
  return _downCmder.apply(this, arguments);
}

function _downCmder() {
  _downCmder = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee4(releaseUrl, zipFile) {
    var html, zipUrl;
    return _regenerator.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return spawn([curl, "--location", releaseUrl], {
              argv0: "curl",
              encoding: "utf8" // echo: true,

            });

          case 2:
            html = _context4.sent;
            zipUrl = urlResolve(releaseUrl, /\s+href=('|")(.+?\/cmder_mini.zip)\1/i.exec(html)[2]);
            _context4.next = 6;
            return spawn([curl, "--fail", "--insecure", "--location", "--remote-time", "--continue-at", "-", "--output", gitWin.toWin32(zipFile), zipUrl], {
              argv0: "curl",
              stdio: "inherit",
              echo: true,
              env: Object.assign({
                https_proxy: process.env.npm_config_https_proxy
              }, process.env)
            });

          case 6:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));
  return _downCmder.apply(this, arguments);
}

function getCmder() {
  return _getCmder.apply(this, arguments);
}

function _getCmder() {
  _getCmder = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee5() {
    var releaseUrl, cmderVer, cmderDir, unzip, zipFile, clinkFile, clinkConfig;
    return _regenerator.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            if (!process.env.CI) {
              _context5.next = 2;
              break;
            }

            return _context5.abrupt("return");

          case 2:
            _context5.next = 4;
            return getLocation("https://github.com/cmderdev/cmder/releases/latest");

          case 4:
            releaseUrl = _context5.sent;
            cmderVer = /\/v*([^/\\]+?)$/.exec(releaseUrl)[1];
            cmderDir = path.join(process.env.ProgramData, "Cmder");
            _context5.next = 9;
            return checkCmder(cmderDir, cmderVer);

          case 9:
            if (_context5.sent) {
              _context5.next = 23;
              break;
            }

            unzip = gitWin.toWin32("/usr/bin/unzip.exe");
            zipFile = `/tmp/cmder_mini_v${cmderVer}.zip`;
            _context5.prev = 12;
            _context5.next = 15;
            return spawn([unzip, "-t", zipFile], {
              argv0: "unzip",
              stdio: "ignore" // echo: true,

            });

          case 15:
            _context5.next = 21;
            break;

          case 17:
            _context5.prev = 17;
            _context5.t0 = _context5["catch"](12);
            _context5.next = 21;
            return downCmder(releaseUrl, zipFile);

          case 21:
            _context5.next = 23;
            return spawn([unzip, "-o", "-d", cmderDir, zipFile], {
              argv0: "unzip",
              stdio: ["inherit", "pipe", "inherit"],
              echo: true
            });

          case 23:
            clinkFile = path.join(cmderDir, "vendor/clink.lua");
            _context5.next = 26;
            return promisify(fs.readFile)(clinkFile, "utf8");

          case 26:
            clinkConfig = _context5.sent;
            clinkConfig = clinkConfig.replace(/λ/g, "$");

            if (!(RegExp.lastMatch === "λ")) {
              _context5.next = 31;
              break;
            }

            _context5.next = 31;
            return promisify(fs.writeFile)(clinkFile, clinkConfig);

          case 31:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, this, [[12, 17]]);
  }));
  return _getCmder.apply(this, arguments);
}

function cmd() {
  return _cmd.apply(this, arguments);
}

function _cmd() {
  _cmd = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee6() {
    var cmdFile, cmd, osArch;
    return _regenerator.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            cmdFile = require.resolve("../bin/git-bash-shell.cmd");
            _context6.next = 3;
            return promisify(fs.readFile)(cmdFile, "utf8");

          case 3:
            cmd = _context6.sent;
            osArch = /64$/.test(process.env.PROCESSOR_ARCHITEW6432 || process.arch) ? 64 : 86;
            cmd = cmd.replace(/(\bclink_x)\d*/, "$1" + osArch);
            _context6.next = 8;
            return promisify(fs.writeFile)(cmdFile, cmd);

          case 8:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));
  return _cmd.apply(this, arguments);
}

module.exports = Promise.all([autoRun(), getCmder(), cmd()]).then(function () {
  console.log("`git-bash-shell` installation was successful, please restart your terminal!");
}, function (error) {
  console.error(error.stack || error);
  process.exitCode = 1;
});